﻿var dialogCallFieldSettings, dialogCallFieldDelete, deleteId, $elementForDelete;
$(document).ready(function () {
    dialogCallFieldSettings = $("#DialogCallFieldSettings").dialog({
        autoOpen: false,
        resizable: false,
        width: "600",
        height: "auto",
        modal: true,
        buttons:
            [{
                text: Localization_Save,
                click: function () {
                    $("#ItemsError").hide();
                    if ($("#CallFieldSettingsCustomFieldType").val() == "DropDown" && $(".customer-field-items .customer-field-item").length <= 0) {
                        $("#ItemsError").show();
                    }
                    else {
                        SaveSettings();
                    }
                }
            }, {
                text: Localization_Cancel,
                click: function () {
                    dialogCallFieldSettings.dialog("close");
                }
            }]
    });

    dialogCallFieldDelete = $("#DialogCallFieldDelete").dialog({
        autoOpen: false,
        resizable: false,
        width: "600",
        height: "auto",
        modal: true,
        buttons:
        [{
            text: Localization_Yes,
            click: function () {
                $.ajax({
                    url: RQ_URL + "/Admin/CallFields/Delete",
                    type: "POST",
                    data: JSON.stringify({
                        id: deleteId,
                    }),
                    dataType: "html",
                    contentType: "application/json; charset=utf-8",
                    success: function (g) {
                    },
                    error: function (error) { alert(error.responseText); },
                    complete: function () {
                        $elementForDelete.closest(".customer-field").detach();
                        dialogCallFieldDelete.dialog("close");
                    }
                });
            }
        }, {
            text: Localization_No,
            click: function () {
                dialogCallFieldDelete.dialog("close");
            }
        }]
    });

    $(".draggable").draggable({
        connectToSortable: '#sortable',
        helper: "clone",
        stop: function (event, ui) {
            if ($("#sortable").find(".draggable").length > 0) {
                var position = $("#sortable").find(".draggable").index();
                var type = $("#sortable").find(".draggable").data("type");
                $("#sortable").find(".draggable").html("<div class='loading-32'></div>");
                $.ajax({
                    url: RQ_URL + "/Admin/CallFields/AddType",
                    type: "POST",
                    data: JSON.stringify({
                        type: type,
                        index: position,
                    }),
                    dataType: "html",
                    contentType: "application/json; charset=utf-8",
                    success: function (g) {
                        if (position == 0) {
                            $("#sortable").prepend(g);
                        } else {
                            $("#sortable > div.customer-field:nth-child(" + (position) + ")").after(g);
                        }
                        $("#sortable").find(".draggable").detach();
                    },
                    error: function (error) { alert(error.responseText); },
                    complete: function () {
                    }
                });
            }
            initBsTooltip();
        },
    });

    $("#sortable, div.customer-field").disableSelection();
    $("#sortable").droppable({
        accept: "div.draggable",
        drop: function (event, ui) {
        },
    }).sortable({
        items: ".customer-field",
        handle: ".handle",
        placeholder: "ui-state-highlight-customer-field",
        stop: function (event, ui) {
            var position = $("#sortable").find(".draggable").index();
            var ids = $(".customer-fields-left-box .content .customer-field").map(function () {
                return $(this).data("id");
            }).get();
            $.ajax({
                url: RQ_URL + "/Admin/CallFields/ChangePositions",
                type: "POST",
                data: JSON.stringify({
                    ids: ids
                }),
                dataType: "html",
                contentType: "application/json; charset=utf-8",
                success: function (g) {
                },
                error: function (error) { alert(error.responseText); },
                complete: function () {
                }
            });
        }
    });

    $(".customer-fields-left-box").on("click", ".customer-field .fa-cog", function () {
        var id = $(this).closest(".customer-field").data("id");
        dialogCallFieldSettings.html("<div class='loading-32'></div>");
        dialogCallFieldSettings.dialog("open");
        $.ajax({
            url: RQ_URL + "/Admin/CallFields/GetSettings",
            type: "POST",
            data: JSON.stringify({
                id: id,
            }),
            dataType: "html",
            contentType: "application/json; charset=utf-8",
            success: function (g) {
                dialogCallFieldSettings.html(g);
                initSortableDropDownItems();
                if ($("#CallFieldSettingsCustomFieldType").val() == "DropDown") {
                    if ($("#CallFieldSettingsPleaseSelect").is(":checked")) {
                        $("#CallFieldSettingsRequired").prop("disabled", false);
                    }
                    else {
                        $("#CallFieldSettingsRequired").prop("disabled", true);
                        $("#CallFieldSettingsRequired").prop("checked", false);
                    }
                }
                dialogCallFieldSettings.dialog("close");
                dialogCallFieldSettings.dialog("open");
            },
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
    });

    $(".customer-fields-left-box").on("click", ".customer-field .fa-trash", function () {
        dialogCallFieldDelete.dialog("open");
        deleteId = $(this).closest(".customer-field").data("id");
        $elementForDelete = $(this);
       
    });

    $("#DialogCallFieldSettings").on("click", "#CallFieldSettingsPleaseSelect", function () {
        if ($("#CallFieldSettingsCustomFieldType").val() == "DropDown") {
            if ($(this).is(":checked")) {
                $("#CallFieldSettingsRequired").prop("disabled", false);
            }
            else {
                $("#CallFieldSettingsRequired").prop("disabled", true);
                $("#CallFieldSettingsRequired").prop("checked", false);
            }
        }
    });

    $("#DialogCallFieldSettings").on("click", ".customer-field-item .fa-trash-o", function () {
        $(this).closest(".customer-field-item").remove();
    });

    $("#DialogSubmitterBoxSettings").dialog({
        autoOpen: false,
        resizable: false,
        width: "600",
        height: "auto",
        modal: true,
        buttons:
        [{
            text: Localization_Ok,
            click: function () {
                $("#DialogSubmitterBoxSettings").dialog("close");
            }
        }]
    });

    $("#DialogSubmitterBoxSettings").on("change", "#CallAndUserFields", function () {
        if ($("#CallAndUserFields").val() != null && $("#CallAndUserFields").val() != "") {
            addNewSubmitterFieldBox($("#CallAndUserFields").val());
            var optionSelected = $("option:selected", this);
            optionSelected.attr("disabled", "disabled");
            $("#CallAndUserFields").val(null).trigger("change");
            SearchableCombos();
        }
    });

    $("#DialogSubmitterBoxSettings").on("click", ".submitter-box-field .fa-trash", function () {
        var id = $(this).closest(".submitter-box-field").data("id");
        var optionSelected = $("#CallAndUserFields option[value='" + $(this).closest(".submitter-box-field").data("select2id") + "']");
        optionSelected.removeAttr("disabled");
        SearchableCombos();
        $(this).closest(".submitter-box-field").remove();
        $.ajax({
            url: RQ_URL + '/Admin/SubmitterBoxSettings/Delete',
            data: {
                id: id
            },
            type: "POST"
        });
    });
});

function SaveSettings() {
    OnAjaxBegin(Localization_Saving);
    if ($("#CallFieldSettingsCustomFieldType").val() == "ID" && $("#CallFieldSettingsUnique").is(":checked")) {
        $.ajax({
            url: RQ_URL + "/Admin/CallFields/CheckIsUnique",
            type: "POST",
            data: JSON.stringify({
                Id: $("#CallFieldSettingsId").val(),
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: function (g) {
                if (g == true) {
                    CallSaveSettings();
                }
                else {
                    OnAjaxComplete();
                    $("#CallFieldSettingsUnique").closest(".form-group").find(".valid-error").show();
                }
            },
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
    }
    else {
        CallSaveSettings();
    }
}

function CallSaveSettings() {
    var items = Array();
    $(".customer-field-items .customer-field-item").each(function (index, value) {
        items.push({
            IsNew: $(value).data("isnew"),
            Id: $(value).data("id"),
            Index: index,
            Title: $(value).find("input[type='text']").val(),
        });
    });

    $.ajax({
        url: RQ_URL + "/Admin/CallFields/SaveSettings",
        type: "POST",
        data: JSON.stringify({
            Id: $("#CallFieldSettingsId").val(),
            CustomFieldTitle: $("#CallFieldSettingsCustomFieldTitle").val(),
            DoNotShow: $("#CallFieldSettingsDoNotShow").is(":checked"),
            Required: $("#CallFieldSettingsRequired").is(":checked"),
            HintText: $("#CallFieldSettingsHintText").val(),
            IsUnique: $("#CallFieldSettingsUnique").is(":checked"),
            PleaseSelect: $("#CallFieldSettingsPleaseSelect").is(":checked"),
            MinLength: $("#CallFieldSettingsMinLength").val(),
            MaxLength: $("#CallFieldSettingsMaxLength").val(),
            Items: items
        }),
        dataType: "html",
        contentType: "application/json; charset=utf-8",
        success: function (g) {
            var id = $("#CallFieldSettingsId").val();
            $(".customer-field[data-id='" + id + "']").after(g);
            $(".customer-field[data-id='" + id + "']").first().detach();
            dialogCallFieldSettings.dialog("close");
        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
            OnAjaxComplete();
        }
    });
}

function addNewRow() {
    $(".customer-field-items").append("<div class='customer-field-item' data-isnew='true'> <i class='fa fa-fw fa-arrows handle'></i><input type='text' /><i class='fa fa-fw fa-trash-o cursor_pointer'></i></div>");
    initSortableDropDownItems();
}

function initSortableDropDownItems() {
    $(".customer-field-items").sortable({
        items: ".customer-field-item",
        handle: ".handle"
    });
}

function showSubmitterBoxSettingDialog() {
    $("#DialogSubmitterBoxSettings").dialog("open");
    $("#DialogSubmitterBoxSettings").html("<div class='loading-32'></div>");
    $("#DialogSubmitterBoxSettings").load(RQ_URL + "/Admin/SubmitterBoxSettings/GetSubmitterBoxSettings", function () {
        $("#DialogSubmitterBoxSettings").dialog("close");
        $("#DialogSubmitterBoxSettings").dialog("open");
    });
}

function addNewSubmitterFieldBox(id) {
    $.ajax({
        url: RQ_URL + "/Admin/SubmitterBoxSettings/Add",
        type: "POST",
        data: JSON.stringify({
            id: id
        }),
        dataType: "html",
        contentType: "application/json; charset=utf-8",
        success: function (g) {
            $("#SubmitterBoxSettings").append(g);
        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
        }
    });
}