﻿$(document).ready(function () {
    $("body").on("change", "#SelectedPortal", function () {
        reloadPortal();
    });

    $("body").on("click", ".js-category > .js-portal-category-item-row", function (e) {
        var categoryId = $(this).parent().data("id");
        loadCategory(categoryId);
        setCategoryAsSelected(categoryId);
    });

    $("body").on("click", ".js-category .fa-angle-down", function (e) {
        e.stopPropagation();
        $rootElement = $(this).closest(".js-category");
        openArrow($rootElement, false);
    });

    $("body").on("click", ".js-category .fa-angle-right", function (e) {
        e.stopPropagation();
        $(this).addClass("fa-angle-down");
        $(this).removeClass("fa-angle-right");
        $rootElement = $(this).closest(".js-category");
        $rootElement.children(".js-sub-categories").hide();
    });

    $("body").on("click", ".js-portal-item .js-cog", function () {
        event.preventDefault();
        var itemId = $(this).closest(".js-portal-item").data("itemid");
        window.location = RQ_URL + "/Admin/Portals/Edit/" + $("#SelectedPortal").val() + "?portalItemId=" + itemId;
    });
    
    $("body").on("click", ".js-portal-item .js-star", function () {
        event.preventDefault();
        var $element = $(this);
        var itemId = $(this).closest(".js-portal-item").data("itemid");
        var categoryId = $(this).closest(".js-portal-item").data("category");
        var withoutCategory = $(this).closest(".js-portal-items").hasClass("js-portal-items-without-category");
        $.ajax({
            url: RQ_URL + "/Portal/SetPortalItemFavorite",
            type: "POST",
            data: JSON.stringify({
                id: itemId,
                favorite: $(this).hasClass("far")
            }),
            contentType: "application/json; charset=utf-8",
            success: function (g) {
            },
            error: function (error) { alert(error.responseText); },
            complete: function () {
                if ($($element).hasClass("far")) {
                    $($element).addClass("fas");
                    $($element).removeClass("far");
                } else {
                    $($element).addClass("far");
                    $($element).removeClass("fas");
                }
                if (withoutCategory) {
                    loadWithoutCategory();
                }
                else if (categoryId != undefined) {
                    loadCategory(categoryId);
                }
                else {
                    loadHome();
                }
            }
        });
    });
}); //end document ready

function reloadPortal() {
    $("#js-PortalBody").html("<div class='loading-32'></div>");
    window.location = RQ_URL + "/Portal/Index/" + $("#SelectedPortal").val();
}

var openCategories = [];
var homeLoaded = true;

function loadCategory(id) {
    $("#js-PortalCategoryBody").html("<div class='loading-32'></div>");
    $.ajax({
        url: RQ_URL + "/Portal/LoadCategory",
        type: "POST",
        data: JSON.stringify({
            id: id
        }),
        contentType: "application/json; charset=utf-8",
        success: function (g) {
            homeLoaded = false;
            openCategories = g.categoryPath;
            openNextCategory();
            $("#js-PortalCategoryBody").html(g.html);
        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
        }
    });
}

function loadHome() {
    $(".js-portal-categories .js-portal-category-item-row.selected").removeClass("selected");
    $("#js-PortalCategoryBody").html("<div class='loading-32'></div>");
    $("#js-PortalCategoryBody").load(RQ_URL + "/Portal/LoadHome/" + $("#SelectedPortal").val(),
        function (responseText, textStatus, XMLHttpRequest) {
            if (textStatus == "error") {
                alert(XMLHttpRequest.responseText);
            }
            homeLoaded = true;
        });
}

function loadWithoutCategory() {
    $(".js-portal-categories .js-portal-category-item-row.selected").removeClass("selected");
    $(".js-portal-items-without-category").html("<div class='loading-32'></div>");
    $(".js-portal-items-without-category").load(RQ_URL + "/Portal/LoadItemsWithoutCategory/" + $("#SelectedPortal").val(),
        function (responseText, textStatus, XMLHttpRequest) {
            if (textStatus == "error") {
                alert(XMLHttpRequest.responseText);
            }
            if (homeLoaded) {
                loadHome();
            }
        });
}

function openArrow($rootElement, setSelected) {
    $i = $rootElement.find("> .js-portal-category-item-row > i[class^='fa']");
    if ($i.hasClass("fa-angle-down")) {
        $i.removeClass("fa-angle-down");
        $i.addClass("fa-angle-right");
    }
    if (setSelected) {
        setCategoryAsSelected($rootElement.data("id"));
    }
    if ($rootElement.children(".js-sub-categories").data("haschildren") == true) {
        if ($rootElement.children(".js-sub-categories").data("loaded") != true) {
            $rootElement.children(".js-sub-categories").html("<div class='loading-16'></div>");
            $rootElement.children(".js-sub-categories").load(RQ_URL + "/Portal/LoadSubCategories/" + $rootElement.data("id"),
                function (responseText, textStatus, XMLHttpRequest) {
                    if (textStatus == "error") {
                        alert(XMLHttpRequest.responseText);
                    } else {
                        openNextCategory();
                    }
                });
            $rootElement.children(".js-sub-categories").data("loaded", true);
        }
        else {
            openNextCategory();
        }
    }
    $rootElement.children(".js-sub-categories").show();
}

function openNextCategory() {
    if (openCategories.length > 0) {
        var cId = openCategories[0];
        openCategories.splice(openCategories.indexOf(cId), 1);
        openArrow($('.js-category.portal-category-item[data-id="' + cId + '"]'), openCategories.length == 0);
    }
}

function setCategoryAsSelected(categoryId) {
    $(".js-portal-categories .js-portal-category-item-row.selected").removeClass("selected");
    $('.js-category.portal-category-item[data-id="' + categoryId + '"] > .js-portal-category-item-row').addClass("selected");
}

